Subject: Re: MultiPath Routing

From: pravin b shelar <[email-masked]>
Date: Fri, 19 May 2006 18:51:56 +0530

>Christian Schmid <[email-masked]> wrote:
>> 
>> Since this seems to be an undocumented feature.... How is this equal-cost multipath supposed to 
>> work? I just want to send outgoing traffic over two gateways. I tried this:
>> 
>> ip route replace default scope global nexthop via 192.168.0.1 dev eth1 weight 100 nexthop via 
>> 192.168.0.100 dev eth1 weight 100
>> 
>> It it doesnt work. It always uses the last for all download-users (around a few hundreds)
>
>Did you enable IP_ROUTE_MULTIPATH_CACHED? If so please disable it
>since it breaks multipath routing for forwarded traffic.

Hi ,
	This was a bug reported by Christian Schmid long back. It is related to equal cost multipath caching on forwarded traffic. The solution suggested for this was 
to disable equal-cost multipath caching. But It does not look like a clean solution.

I investigated the problem further and observed that, If multipath caching is "on" then all route entries are added to the route cache. This leads to selection of same
NIC for all route going through this ( forwarding ) sever. This is because we don't have selection logic for forwarded traffic in multipath caching code.

On digging this list further, I found a patch posted by Herbert, which  disables multipath route cache entry addition for input case.
I tested this patch and everything works fine now.
for the patch ref: http://oss.sgi.com/projects/netdev/archive/2005-04/msg00232.html

So how about including this patch ?

Comments ?

Regards,
Pravin.